aboutsummaryrefslogtreecommitdiff
path: root/share/hydra/deploy
diff options
context:
space:
mode:
Diffstat (limited to 'share/hydra/deploy')
-rwxr-xr-xshare/hydra/deploy45
1 files changed, 45 insertions, 0 deletions
diff --git a/share/hydra/deploy b/share/hydra/deploy
new file mode 100755
index 0000000..5904f5d
--- /dev/null
+++ b/share/hydra/deploy
@@ -0,0 +1,45 @@
+#!/bin/bash
+#
+# Deploy a node using automated recipes.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as
+# published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public
+# License along with this program. If not, see
+# <http://www.gnu.org/licenses/>.
+
+# Load
+source $APP_BASE/lib/hydra/functions || exit 1
+hydra_config_load
+
+# Command line arguments
+NODES="$*"
+
+# Build node list
+if [ -z "$NODES" ]; then
+ NODES="`hydra $HYDRA nodes`"
+fi
+
+# Deploy
+for node in $NODES; do
+ echo "Deploying to $node..."
+
+ # Sync repository to server
+ rsync -rlptD --delete --remote-rsync "sudo rsync" $HYDRA_FOLDER/puppet/ $node:/etc/puppet/
+
+ # Run puppet
+ $HYDRA_CONNECT $node <<EOF
+ ##### BEGIN REMOTE SCRIPT #####
+ sudo chown -R root. /etc/puppet
+ sudo puppet apply /etc/puppet/manifests/nodes/\$(facter fqdn).pp
+ ##### END REMOTE SCRIPT #######
+EOF
+done